/***********************************************************************
 * Copyright 2009, Matthew Alden
 *
 * This file is part of MARLEDA.
 *
 * MARLEDA is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MARLEDA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MARLEDA.  If not, see <http://www.gnu.org/licenses/>.
 ***********************************************************************/

#include "BinaryEvolutionTask.h"
	

using namespace std;


bool BinaryEvolutionTask::initAlleles(const ParameterSet& ps, AllelePool& ap) {
	try {
		ap.newAllele("0");
		ap.newAllele("1");
	} catch (invalid_argument& ex) {
		return false;
	}
	return true;
}

bool BinaryEvolutionTask::init(ParameterSet& ps, const AllelePool& ap) {
	try {
		OFF = ap.get("0");
		ON = ap.get("1");
	} catch (invalid_argument& ex) {
		return false;
	}
	return true;
}
