/***********************************************************************
 * Copyright 2009, Matthew Alden
 *
 * This file is part of MARLEDA.
 *
 * MARLEDA is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MARLEDA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MARLEDA.  If not, see <http://www.gnu.org/licenses/>.
 ***********************************************************************/

#ifndef _SPINGLASS_H_
#define _SPINGLASS_H_


#include <vector>
#include "BinaryEvolutionTask.h"


class SpinGlass : public BinaryEvolutionTask {
public:
	bool init(ParameterSet& ps, const AllelePool& ap);
	using BinaryEvolutionTask::evaluate;
        double evaluate(const Chromosome& c);
#ifdef USE_PLOTTER
	bool plot(const char* filename);
	bool plot(const Chromosome& c, const char* filename);
#endif

private:
	struct coupling {
		long spin1, spin2;
		double strength;
	};

	long width, height;
	std::vector<coupling> couplings;
};


#endif
